extern int     TZselect_Brk0_UTC1_NY2     =  2;
                        #define TZ_BROKER 0
                        #define TZ_UTC    1
                        #define TZ_NY     2
                        string   TZselect_txt[] = {"Brk", "UTC", "NY"};
extern int     AnalyzeDays_OffsetHrs      =  16;
#define HR2400 86400       // 24 * 3600
int      TimeOfDay(datetime when){  return( when % HR2400          );         }
datetime DateOfDay(datetime when){  return( when - TimeOfDay(when) );         }
//datetime Today(){                   return(DateOfDay( TimeCurrent() ));       }
//datetime Tomorrow(){                return(Today() + HR2400);                 }
//datetime Yesterday(){               return( iTime(NULL, PERIOD_D1, 1) );      }
//+------------------------------------------------------------------+
//| Analyze Charts                                                   |
//+------------------------------------------------------------------+
#define iCB 0  // Current Bar
#define iPB 1  // Previous Bar
   #define ACR_TIME     0  // Array Copy Rates
   #define ACR_OPEN     1
   #define ACR_LOW      2
   #define ACR_HIGH     3
   #define ACR_CLOSE    4
// #define ACR_VOLUME   5
      #define ACR_COUNT    6
double   d1_acr[][ACR_COUNT];                   // Export to NewTrade/SetStops
datetime DayStart(){ return(d1_acr[iCB][ACR_TIME]);                           }
void     OnInitD1Adj(){
   if( !MyArrayResize(d1_acr, 1, "D1acr") )                          return;
   d1_acr[iCB][ACR_TIME] = 0; // First time.
   #define ANALYZED_DAYS_MAX 99
   if(AnalyzeDays_Count < 3 || AnalyzeDays_Count > ANALYZED_DAYS_MAX){
      AlertMe("AnalyzeDays_Count ="+AnalyzeDays_Count,
               " must be 3.."+ANALYZED_DAYS_MAX+"(ANALYZED_DAYS_MAX)");
      AnalyzeDays_Count = MathMaxI( 3, MathMinI(ANALYZED_DAYS_MAX,
                                                AnalyzeDays_Count) );         }
}  // OnInitD1Adj
datetime nextD1Adj;  void  CallAgainDayNext(){  CallAgainOn(nextD1Adj,"Tom"); }
void     OnTickD1Adj(){
   int      offset   = AnalyzeDays_OffsetHrs * 3600;
   datetime BODsrv   = d1_acr[iCB][ACR_TIME];
   if(BODsrv == 0){  int   iBOD  = Bars - 1;       BODsrv   = Time[iBOD];  }
   else                    iBOD  = iGetShift(BODsrv);
   while(true){   // Create all daily bars.
      datetime       next     = TimeSrvToTZ(BODsrv + HR2400),
                  nextAdj  = DateOfDay(next - offset) + offset;
      nextD1Adj   = TimeTzToSrv(nextAdj); // Next adjusted day start (estimated)
      int      iEOD  = iGetShift(nextD1Adj); // Find nearest bar.
      if(Time[iEOD] == nextD1Adj)   iEOD++;  // Exact, make iEOD inclusive.
      if(iBOD == iEOD && iEOD != iCB){
         // Based on IBFX market history for eurusd/audusd the market closed 5pm
         // from 2011.03.12 through 05.14. This is not confirmed by USDCZK (H4)
         // [IBFX history only] so I think it's bad history from trueFX. Thus
         // sometimes there is an extra M1 bar on Friday at 2100z that results
         // in a 1 minute daily bar. Don't want that.
         iBOD = iEOD - 1;           BODsrv = Time[iBOD];
         continue;   }  // Skip the one minute bar.
      int      iHH   = iGetHighest(iBOD+1, iEOD),
               iLL   = iGetLowest( iBOD+1, iEOD);
      d1_acr[iCB][ACR_TIME]   = BODsrv;
      d1_acr[iCB][ACR_OPEN]   =  Open[iBOD];
      d1_acr[iCB][ACR_CLOSE]  = Close[iEOD];
      d1_acr[iCB][ACR_HIGH]   =  High[iHH];
      d1_acr[iCB][ACR_LOW]    =   Low[iLL];
      if(iEOD == iCB)   break;   // Update complete.
      iBOD = iEOD - 1;           BODsrv = Time[iBOD];
      int      nBars = ArrayRange(d1_acr,0);
      if( !ResizeBuffer(d1_acr, nBars + 1) ) return;
   }  // Create all daily bars.
}  // OnTickD1Adj
void     NewTrade(){
	{	OnTickD1Adj();	CallAgainDayNext();	}	// new oopb
   double   oopb     = d1_acr[iCB][ACR_OPEN],
            hotd     = d1_acr[iCB][ACR_HIGH],
            lotd     = d1_acr[iCB][ACR_LOW],
:
bool     MyArrayResize(double& arr[], int nRows, string msg){
   if( ArrayResize(arr, nRows) >= nRows)  return(true);
   DisableTrading( "ArrayResize("+nRows+") Failed: "+GetLastError() +" "+msg);
   return(false);
}
bool     ResizeBuffer(double& buffer[], int size){ // buffer can be 1D or 2D
   if(ArrayRange(buffer,0) != size){      // ArrayRange allows 1D or 2D arrays
      ArraySetAsSeries(buffer, false);    // Shift values B[2]=B[1]; B[1]=B[0]
      if( !MyArrayResize(buffer, size, "ResizeBuffer") )	return(false);
      ArraySetAsSeries(buffer, true);
   }
   return(true);
}
void     OnInitUTC(){
   if(Srvr_To_UTC_Auto){
      if		  ( IsTesting() ){	Srvr_To_UTC_Auto = false;
         AlertMe( "Warning, use manual UTCoffsets only on backtest.",
            " Automatic UTC offset calculation disabled." );                 	}
      else  if( !IsDllsAllowed() ){
         AlertMe( "Dll calls must be allowed to compute server time to UTC" );}
      else{
         double   stuh = Srvr_To_UTC_Hours;        // Update Srvr_To_UTC_Hours
         TimeSrvToUTC( TimeCurrent() );           	// before first tick.
         if(stuh != Srvr_To_UTC_Hours){
            Print("Srvr_To_UTC_Hours changed to ", Srvr_To_UTC_Hours);
            Log(  "Srvr_To_UTC_Hours changed to ", Srvr_To_UTC_Hours);        }
}  }  }
datetime TimeSrvToUTC(datetime timeSrv=EMPTY){     // Server time to UTC time
   if(timeSrv == EMPTY) timeSrv = timeCur_srv;
   static datetime   nextAutoUpdate;      if(timeSrv >= nextAutoUpdate){
      nextAutoUpdate = timeSrv + HR2400;
      if(Srvr_To_UTC_Auto) if(
         IsDllsAllowed()){                            // Complained @ init
         int      srvrToUTC         = LocalTimeToUTC() - TimeCurrent();
         double   nearestHalfHour   = MathRound(srvrToUTC / 1800.);
         Srvr_To_UTC_Hours          = nearestHalfHour / 2.; // Update external
      }
   }
   return(timeSrv + Srvr_To_UTC_Hours*3600.);
}
datetime TimeUtcToSrv(datetime timeUTC){              // Server time to GMT time
   return(timeUTC - Srvr_To_UTC_Hours*3600.);
}
#import "kernel32.dll"
int    GetTimeZoneInformation(int& TZInfoArray[]);
#import
datetime LocalTimeToUTC(){   // TimeLocal to GMT forum.mql4.com/12057#522900
   // This is called only by TimeGMT. Check for IsDLLsAllowed() done there.
   int      TZInfoArray[43];
   int      tz = GetTimeZoneInformation(TZInfoArray);
   int      GMTshift = TZInfoArray[0]; // GetTimeZoneInformation will return
   #define TIME_ZONE_ID_DAYLIGHT 2     // the right Bias even when it returns
   #define TIME_ZONE_ID_UNKNOWN  0     // UNKNOWN
   if(tz == TIME_ZONE_ID_DAYLIGHT || tz == TIME_ZONE_ID_UNKNOWN)
      GMTshift += TZInfoArray[42];
   return (TimeLocal() + GMTshift*60);
//{msdn.microsoft.com/en-us/library/windows/desktop/ms724421%28v=vs.85%29.aspx
// typedef struct _TIME_ZONE_INFORMATION {      typedef struct _SYSTEMTIME {
// LONG        Bias;           [ 0]  (min)   WORD wYear;       [0]
// WCHAR       StandardName[32];  [ 1]       WORD wMonth;            Jan=1
// SYSTEMTIME  StandardDate;      [17]       WORD wDayOfWeek;  [1]   Sun=1
// LONG        StandardBias;      [21]       WORD wDay;
// WCHAR       DaylightName[32];  [22]       WORD wHour;       [2]
// SYSTEMTIME  DaylightDate;      [38]       WORD wMinute;
// LONG        DaylightBias;      [42]       WORD wSecond;     [3]
//                                   }       WORD wMilliseconds;              }
//}
}
//+------------------------------------------------------------------+
//| NY Time                                                          |
//+------------------------------------------------------------------+
datetime TimeSrvToNY(datetime timeSrv=EMPTY){      // Server time to NY time
   if(timeSrv == EMPTY) timeSrv = timeCur_srv;
      #define NY_TZ_STD -5                   // NY is UTC-5 (STD) or UTC-4 (DST)
   int utcToNY = NY_TZ_STD + IsNYonDST(timeSrv);
   return(TimeSrvToUTC(timeSrv) + utcToNY * 3600);
}
datetime TimeNyToSrv(datetime timeNY){
   int utcToNY = NY_TZ_STD + IsNYonDST(timeNY);
   return( TimeUtcToSrv(timeNY - utcToNY * 3600) );
}
bool     IsNYonDST(datetime whenNY){
   //{Market opens Sunday 6PM ET (NY local time) and closes Friday 4PM ET. DST
   // changes at 2AM Sunday, when the market is closed. I don't have to worry
   // about the passed time here, only the date.
   //}
   int      year  = TimeYear(       whenNY);             #define MARCH      3
   int      mon   = TimeMonth(      whenNY);             #define APRIL      4
   int      dom   = TimeDay(        whenNY);             #define OCTOBER   10
   int      dow   = TimeDayOfWeek(  whenNY);             #define NOVEMBER  11
   //{   http://en.wikipedia.org/wiki/Daylight_saving_time_in_the_United_States
   //                                     #History_of_DST_in_the_United_States
   // 1986-2006   DST the first Sunday in April to the last Sunday in October
   // 2007 on              second Sunday March        first Sunday in November
   //}
   if(year < 2007){  int   monBeg=APRIL,  secndSun=0,  monEnd=OCTOBER;        }
   else{                   monBeg=MARCH;  secndSun=7;  monEnd=NOVEMBER;       }
   if(mon < monBeg)                       return(false); // Early spring.
   if(mon > monEnd)                       return(false); // Late fall.
   if(mon != monBeg){   if(mon != monEnd) return(true);  // Summer.
      if(year < 2007){  // Find last Sun = dom - (dow-SUNDAY) but SUNDAY==0
         for(int lastSun = dom-dow; lastSun+7 <= 31; lastSun += 7){}
         return (dom < lastSun);                         // DST Before Sun. &
   }  }                                                  // not on markt open
   // Otherwise first or second Sunday of MonBegin or first Sunday of MonEnd
   for(int firstSun = dom + 7-dow; firstSun > 7; firstSun -= 7){}
   if(mon == monBeg) return (firstSun+secndSun <= dom);  // DST On/After
   return (dom < firstSun);                              // DST Before Sun.
}
bool  IsLeapYear(int year){   return(year%4==0 && year%100!=0 && year%400==0); }
int   DaysOfMonth(datetime when){
                        // Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec
   static int     dpm[] =  {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
   int      mo = TimeMonth(when);
   if(mo != 2) return(dpm[mo-1]);
               return(dpm[mo-1] + IsLeapYear(TimeYear(when)));           // Feb
}
//+------------------------------------------------------------------+
//| Time when market closes.                                         |
//+------------------------------------------------------------------+
datetime TimeWEsrv(){
   static datetime   mktClosesSrv;
   if(timeCur_srv > mktClosesSrv + HR2400){        // Compute next market close
      //{Market closes Friday 4PM ET (NY local time)  2000z or 2100z.
      // And opens Sunday 6PM ET 2200z or 2300z
      // 21:00 Friday      GMT/UTC                 22:00 Sunday
      // 16:00 Friday      America/New_York        18:00 Sunday
      // 10:00 Friday      Pacific/Honolulu        13:00 Sunday
      // 05:00 Saturday    Asia/Tokyo              08:00 Monday
      // 06:00 Saturday    Australia/Melbourne     10:00 Monday
      //}
      #define DOW_FRIDAY   5
      int      dow         = TimeDayOfWeek(timeCur_srv);
      datetime    bod      = DateOfDay(timeCur_srv),
               friday      = bod + HR2400 * (DOW_FRIDAY - dow);
      #define HR1600       57600    // 4 PM
      mktClosesSrv = TimeNyToSrv(friday + HR1600);
   }                                         // Compute next market close
   return(mktClosesSrv);
}
//+------------------------------------------------------------------+
//| TZ Time                                                          |
//+------------------------------------------------------------------+
datetime TimeSrvToTZ(datetime timeSrv=EMPTY){
   if(timeSrv == EMPTY) timeSrv = timeCur_srv;
   switch(TZselect_Brk0_UTC1_NY2){
   case TZ_BROKER:   return(              timeSrv  );
   case TZ_UTC:      return( TimeSrvToUTC(timeSrv) );
   case TZ_NY:       return( TimeSrvToNY( timeSrv) );
}  }
datetime TimeTzToSrv(datetime timeTz){
   switch(TZselect_Brk0_UTC1_NY2){
   case TZ_BROKER:   return(              timeTz  );
   case TZ_UTC:      return( TimeUtcToSrv(timeTz) );
   case TZ_NY:       return( TimeNyToSrv( timeTz) );
}  }
//+------------------------------------------------------------------+
//| Miscellaneous functions                                          |
//+------------------------------------------------------------------+
int      iGetShift(datetime tm, int p=0){
   if(p == 0)  p = Period();
   //{ At http://forum.mql4.com/55743 I report that iBarShift doesn't match the
   // documentation. It returned bar 49 hours earlier instead of bar 1 hour
   //} later, (weekend gap.) This routine returns the nearest bar.
   int      iBar     = iBarShift(NULL, p, tm);
   datetime barBeg   = iTime(NULL, p, iBar),
            barEnd   = barBeg + p * 60;         if(barEnd > tm)   return(iBar);
                                                if(iBar <= 0)     return(iBar);
   datetime nxtBeg   = iTime(NULL, p, iBar - 1);
   if(tm - barEnd > nxtBeg - tm) iBar--;
   return(iBar);                                                              }
int      iGetHighest(int iEnd, int iBeg=0, int p=0){			// Excluding iEnd.
   return( iHighest(NULL,p, MODE_HIGH, iEnd - iBeg, iBeg) ); }
int      iGetLowest( int iEnd, int iBeg=0, int p=0){
   return(  iLowest(NULL,p, MODE_LOW,  iEnd - iBeg, iBeg) ); }
